#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <cmath>
#include <ctime>
#include <malloc.h>
 
 
using namespace std;

void gauss_pairs(double * B1, double * B2, int nelem)

/********************************************************************/

{ /* thanks to G.Ciresi for the reference: Num. Recipes in C, 1992  */
	  double v1,v2,rsq,fac;
	for (int i=0;i<nelem;i++){
  do 
  { 
	v1=rand()/(RAND_MAX+1.0)*2 -1;
	v2=rand()/(RAND_MAX+1.0)*2 -1;    
    rsq = v1*v1 + v2*v2;
  }
    while (rsq >= 1.0 || rsq == 0.0);
    
  fac = sqrt ( -2.0 * log(rsq)/rsq);
   
  B1[i] = v1*fac;
  B2[i] = v2*fac;
}
} 

 
 
extern "C" __declspec(dllexport) int __stdcall MCIS(double *prix_min_std,double *prix_max_std,double *time_std,  double *outfile, double *outfile1, int nelem)
{
    int i, j, k ,  n=10000, nDiscr=100, 
		start, end;


	double *va1=new double[nDiscr], *va2=new double[nDiscr], 
		S, S0=100, K=110, T=0.3, Y, YOld, Y0=-2.32, QT, Somme_pi, Somme_pi_sqr, 
		prix, stdev,prixBS, deltaBS, m=-2.6, rho=-0.3, alpha=.01, 
		integrale=0, r=0., divid=0, vol, volBS,    dt=T/nDiscr;

 
	for(i=0,k=0; i<n; i++)
	{
		if (!((i+1)%(n/nelem))) {
			outfile[k]= i+1;
			k+=1;
		}
	}
	/********************MC Standard**********************/
	start=clock();
 	srand(0);

	Somme_pi=0.;
	Somme_pi_sqr=0.;
	for(i=0,k=0; i<n; i++)
	{

		S=S0;
		Y=Y0;
		gauss_pairs(va1,va2,nDiscr);
		for(j=0; j<nDiscr; j++)
		{
			YOld=Y;
			vol=exp(YOld);
			Y += alpha*(m-Y)*dt + sqrt(2*alpha)*sqrt(dt)*(rho*va1[j]+sqrt(1-rho*rho)*va2[j]);
			S += S*(r*dt+ vol*sqrt(dt)*va1[j]);
		}
		//std::cout<<QT<<"\t"<<S<<"\t"<<Y<<std::endl;
		if (K<S){  
			Somme_pi+= (S-K);	
			Somme_pi_sqr+=(S-K)*(S-K);
		}
		//if (K>S)  Somme_pi+= (K-S);
		if (!((i+1)%(n/nelem))) {
			//cout 
			//	<< i+1 << " " 
			//	<< n/nelem <<  " "
			//	<< k <<endl;
			outfile1[k]=Somme_pi/(i+1) ; k+=1;
 		}
	}
	end=clock();
 
	prix = Somme_pi/n;
	stdev= sqrt((Somme_pi_sqr/n -  prix*prix)/(n-1));
	std::cout << "prix = " << prix <<  
		" stdev = " << stdev <<  
		" prix_min = " << prix - 2*stdev 
		<<  " prix_max = " << prix + 2*stdev
		<<  "   time = " << (double)(end-start)/CLOCKS_PER_SEC
		<<std::endl;
	*prix_min_std=prix - 2*stdev;
	*prix_max_std=prix + 2*stdev;
 	*time_std= (double)(end-start)/CLOCKS_PER_SEC;
 
	return 0;
}
 
int main()
{
	int i=50;
	double *outfile=new double[i], *outfile1=new double[i]    ;
	double prix_min_std,prix_max_std, time_std,prix_min_red,prix_max_red,time_red;
    int j=MCIS(&prix_min_std,&prix_max_std,&time_std,
			outfile,outfile1 ,i);
	std::cout 
		<< "IC_std  = " << prix_min_std <<  " " << prix_max_std << std::endl
		<< "IC_red = " << prix_min_red <<  " " << prix_max_red<<  std::endl
		;
	return 0;
}
